SystemOrganization addCategory: #ConfigurationOfPoemPoem!

Object subclass: #ConfigurationOfPoemPoem
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPoemPoem'!

!ConfigurationOfPoemPoem class methodsFor: 'private' stamp: 'SeungBumKim 1/11/2013 13:37'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfPoemPoem class methodsFor: 'private' stamp: 'SeungBumKim 1/11/2013 13:37'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfPoemPoem class methodsFor: 'metacello tool support' stamp: 'SeungBumKim 1/11/2013 13:37'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPoemPoem class methodsFor: 'metacello tool support' stamp: 'SeungBumKim 1/11/2013 13:37'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfPoemPoem class methodsFor: 'loading' stamp: 'SeungBumKim 1/11/2013 13:37'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfPoemPoem class methodsFor: 'metacello tool support' stamp: 'SeungBumKim 1/11/2013 13:37'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfPoemPoem class methodsFor: 'accessing' stamp: 'SeungBumKim 1/11/2013 13:37'!
project

	^self new project! !

!ConfigurationOfPoemPoem class methodsFor: 'metacello tool support' stamp: 'SeungBumKim 1/11/2013 13:37'!
validate 
	(MetacelloToolBox validateConfiguration: ConfigurationOfDaliotsPlayground) explore.! !

!ConfigurationOfPoemPoem methodsFor: 'baselines' stamp: 'SeungBumKim 1/11/2013 16:15'!
baseline01: spec 
	<version: '0.1-baseline'>
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'ftp://appdal.com/'.
		spec package: 'PoemPoem' with: [spec requires: {'PharoSound'}].
		
		spec project: 'PharoSound' with: [
			spec
				repository: 'http://www.squeaksource.com/PharoSound';
				className: 'ConfigurationOfPharoSound';
				versionString: '3.0';
				loads: #('ALL') ].
			
		].
! !

!ConfigurationOfPoemPoem methodsFor: 'baselines' stamp: 'SeungBumKim 1/11/2013 16:14'!
baseline02: spec 
	<version: '0.2-baseline'>
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'ftp://appdal.com/'.
		spec package: 'PoemPoem' with: [spec requires: {'PharoSound'}].
		
		spec project: 'PharoSound' with: [
			spec
				repository: 'http://www.squeaksource.com/PharoSound';
				className: 'ConfigurationOfPharoSound';
				versionString: '3.0';
				loads: #('ALL') ].
			
		spec project: 'QuickPrototyping' with: [
			spec
				repository: 'http://www.squeaksource.com/DaliotsPlayground';
				className: 'ConfigurationOfDaliotsPlayground';
				versionString: #bleedingEdge;
				loads: #('QuickPrototyping') ].
		].
! !

!ConfigurationOfPoemPoem methodsFor: 'doits' stamp: 'HwaJong 1/11/2013 15:56'!
createProjectClassIfMissing
	(Smalltalk hasClassNamed: 'Project')
		ifFalse: [ Object subclass: #Project ]! !

!ConfigurationOfPoemPoem methodsFor: 'attributes' stamp: 'SeungBumKim 1/11/2013 13:37'!
customProjectAttributes

	Smalltalk at: ##OBCodeBrowser ifPresent: [:ignored | ^#(#OB) ].
    ^#()! !

!ConfigurationOfPoemPoem methodsFor: 'doits' stamp: 'SeungBumKim 1/11/2013 14:07'!
enableSound
	(Smalltalk at: #AbstractSoundSystem) perform: #soundEnabled: with: true.! !

!ConfigurationOfPoemPoem methodsFor: 'accessing' stamp: 'SeungBumKim 1/11/2013 13:37'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !

!ConfigurationOfPoemPoem methodsFor: 'versions' stamp: 'HwaJong 1/11/2013 15:55'!
version001: spec 
	<version: '0.1' imports: #('0.1-baseline') >
	
	spec for: #common do: [
		spec blessing: #development.
		spec author: 'SeungBumKim'.
		spec package: 'PoemPoem' with:  'PoemPoem-SeungBumKim.1'.
		spec preLoadDoIt: #createProjectClassIfMissing.
		spec postLoadDoIt: #enableSound.
		].! !

!ConfigurationOfPoemPoem methodsFor: 'versions' stamp: 'SeungBumKim 1/11/2013 16:17'!
version002: spec 
	<version: '0.2' imports: #('0.2-baseline') >
	
	spec for: #common do: [
		spec blessing: #development.
		spec author: 'SeungBumKim'.
		spec package: 'PoemPoem' with:  'PoemPoem-SeungBumKim.2'.
		spec preLoadDoIt: #createProjectClassIfMissing.
		spec postLoadDoIt: #enableSound.
		].! !
